//import Syphon and OSC libraries
import codeanticode.syphon.*;
import oscP5.*;
import netP5.*;
//create syphon instance
PGraphics canvas;
SyphonServer server;
OscP5 oscP5;
NetAddress myRemoteLocation;
//initialise corner coord
int X1 = 30;
int Y1 = 20;
int X2 = 85;
int Y2 = 20;
int X3 = 85;
int Y3 = 75;
int X4 = 30;
int Y4 = 75;
int X5 = 30;
int Y5 = 20;
//initialise fill color
int fillR = 0;
int fillV = 255;
int fillB = 0;
//initialise stroke color
int strokeR = 255;
int strokeV = 0;
int strokeB = 0;
//initialise strokeWeight
int sW01 = 4;

void setup() {
  //screen size
  size(1080,1080, P3D);
  canvas = createGraphics(1080, 1080, P3D);
  //OSC in port
  oscP5 = new OscP5(this, 12000);
  //Isadora port
  myRemoteLocation = new NetAddress("127.0.0.1", 1234);
  // Create syhpon server to send frames out.
  server = new SyphonServer(this, "Processing Syphon");
}

void draw() {
  canvas.beginDraw();
  canvas.beginShape();
  canvas.background(0);
  canvas.strokeWeight(sW01);
  canvas.lights();
  //stroke color
  canvas.stroke (strokeR,strokeV,strokeB);
  //field color
  canvas.fill (fillR,fillV,fillB);
  canvas.vertex(X1, Y1);  
  canvas.vertex(X2, Y2);
  canvas.vertex(X3, Y3);
  canvas.vertex(X4, Y4);
  canvas.vertex(X1, Y1);
  canvas.endShape();
  canvas.endDraw();
  image(canvas, 0, 0);
  server.sendImage(canvas);
}

void oscEvent(OscMessage theOscMessage) {
  /* check if theOscMessage has the address pattern we are looking for. */
  if (theOscMessage.checkAddrPattern("/X1")==true) {
    //put the value in X1
     X1 = theOscMessage.get(0).intValue();
    return;
  } 
 if (theOscMessage.checkAddrPattern("/Y1")==true) {
     Y1 = theOscMessage.get(0).intValue();
    return;
  } 
   if (theOscMessage.checkAddrPattern("/X2")==true) {
     X2 = theOscMessage.get(0).intValue();
    return;
  } 
   if (theOscMessage.checkAddrPattern("/Y2")==true) {
     Y2 = theOscMessage.get(0).intValue();
    return;
  } 
   if (theOscMessage.checkAddrPattern("/X3")==true) {
     X3 = theOscMessage.get(0).intValue();
    return;
  } 
   if (theOscMessage.checkAddrPattern("/Y3")==true) {
     Y3 = theOscMessage.get(0).intValue();
    return;
  } 
   if (theOscMessage.checkAddrPattern("/X4")==true) {
     X4 = theOscMessage.get(0).intValue();
    return;
  } 
   if (theOscMessage.checkAddrPattern("/Y4")==true) {
     Y4 = theOscMessage.get(0).intValue();
    return;
  } 
  //fill color RVB
 if (theOscMessage.checkAddrPattern("/fillR")==true) {
    fillR = theOscMessage.get(0).intValue();
    return;
  } 
  if (theOscMessage.checkAddrPattern("/fillV")==true) {
    fillV = theOscMessage.get(0).intValue();
    return;
  } 
  if (theOscMessage.checkAddrPattern("/fillB")==true) {
    fillB = theOscMessage.get(0).intValue();
    return;
  } 
  //stroke color RVB
  if (theOscMessage.checkAddrPattern("/strokeR")==true) {
    strokeR = theOscMessage.get(0).intValue();
    return;
  } 
  if (theOscMessage.checkAddrPattern("/strokeV")==true) {
    strokeV = theOscMessage.get(0).intValue();
    return;
  } 
  if (theOscMessage.checkAddrPattern("/strokeB")==true) {
    strokeB = theOscMessage.get(0).intValue();
    return;
  } 
  //stroke weight
   if (theOscMessage.checkAddrPattern("/sW01")==true) {
    sW01 = theOscMessage.get(0).intValue();
    return;
  } 
}
